<template>
  <main class="form-signin">
    <form @submit.prevent="submit">
      <h1 class="d-flex justify-content-center h3 mb-3 fw-normal">Register</h1>

      <input
        v-model="data.email"
        type="email"
        class="form-control"
        placeholder="Email"
        required
      />

      <input
        v-model="data.password"
        type="password"
        class="form-control"
        placeholder="Password"
        required
      />

      <button class="w-100 btn btn-lg btn-primary" type="submit">
        Register
      </button>
    </form>

    <div class="alert alert-info my-3" role="alert" v-if="data.alertMessage">
      {{ data.alertMessage }}
    </div>

    <div class="container my-2 d-flex justify-content-center">
      Already have an account?&nbsp;
      <router-link to="/login">Sign In</router-link>
    </div>
  </main>
</template>

<script>
import { reactive } from "vue";
import { useRouter } from "vue-router";
import { useStore } from "vuex";

export default {
  name: "Register",
  setup() {
    const store = useStore();
    const router = useRouter();

    const data = reactive({
      email: "",
      password: "",
      alertMessage: "",
    });

    store.commit("setAuth", { auth: false });

    const submit = async () => {
      data.alertMessage = "Registering...";
      const response = await fetch("api/check-email", {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
          "Access-Control-Allow-Origin": "*",
        },
        body: JSON.stringify(data),
      });

      const content = await response.json();

      if (content.message == "email found") {
        data.alertMessage = "Email already exist, please login";
      } else if (content.message == "email not found") {
        store.commit("setEmailPassword", {
          email: data.email,
          password: data.password,
        });
        await router.push("/create-profile");
      } else {
        data.alertMessage = "Network Error";
      }
    };

    return {
      data,
      submit,
    };
  },
};
</script>
